package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import com.iceberg.*;
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public final class G3D { //Graphics3D
    public static int centreX,  centreY; //центр дисплея
    private static final float pers = 1.5f; //перспектива
    public static int persX = 150; //перспектива
    public static int persY = 150; //перспектива
    public static int range = 1500; //дальность рендеринга
    
    private static Element3D[] ZBuffer = new Element3D[5000]; //массив для линий
    private static int ZBufferSize = 0; //количество линий в массиве
    
    public static void setCentre(int x, int y) {
        centreX = x;
        centreY = y;
        persX = (int)(centreX*pers);
        persY = (int)(centreY*pers);
    }
        
    
    public static void addFigure(Figure figure) {
        for(int i=0; i<figure.element.length; i++) {
            if(ZBufferSize < ZBuffer.length) { //если ZBuffer не переполнен
                if(figure.element[i].ifVisible()) { //если елемент виден
                    ZBuffer[ZBufferSize] = figure.element[i]; //
                    ZBufferSize++;                             //добавляем элемент
                }
            }
        }
    }
    public static void removeAll() {
        ZBufferSize = 0;
    }
    
    
    
    
    public static void render(Graphics g) {
        quickSort(ZBuffer, 0, ZBufferSize-1);
        for(int i=ZBufferSize-1; i>=0; i--) {
            ZBuffer[i].paint(g);
        }
    }
    
    
    
    
    
    
    private static final int partition(Element3D[] m, int a, int b) {
        int i = a;
        for(int j = a; j <= b; j++) { // просматриваем с a по b
            if (m[j].sz <= m[b].sz) { // если элемент m[j] не превосходит m[b],
               Element3D temp = m[i];                    // меняем местами m[j] и m[a], m[a+1], m[a+2] и так далее...
               m[i] = m[j];                 // то есть переносим элементы меньшие m[b] в начало,
               m[j] = temp;                    // а затем и сам m[b] «сверху»
               i++;                         // таким образом последний обмен: m[b] и m[i], после чего i++
            }
       }
      return i-1;                        // в индексе i хранится <новая позиция элемента m[b]> + 1
    }
    
    private static final void quickSort(Element3D[] m, int a, int b) { //быстрая сортировка
         // a - начало подмножества, b - конец
         // для первого вызова: a = 0, b = <элементов в массиве> - 1
         if (a >= b) return;
         int c = partition (m, a, b);
         quickSort (m, a, c-1);
         quickSort (m, c+1, b);
    }
    
    
    
    
    
    
    
    
    
    
}