package com.iceberg;

import java.io.DataInputStream;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import java.io.IOException;



/**
 * @author DDDEN!SSS
 */
public class Vertex { //класс вершина
    public short xReal,  yReal,  zReal; //стандартные 3D координаты
    public short x,  y,  z; //повёрнутые 3D координаты
    public short sx,  sy; //координаты на дисплее
    
    public Vertex(DataInputStream dis) {
        try {
            x = xReal = dis.readShort();
            y = yReal = dis.readShort();
            z = zReal = dis.readShort();
        } catch (IOException ex) {System.err.println("ERROR new Vertex "+ex);}
        set2D();
    }
    
    
    
    
    private final void set2D() {
        int Z = Math.abs(z);
        if(Z == 0) {
            Z=1;
        }
        sx = (short)(G3D.centreX + x * G3D.persX / Z);
        sy = (short)(G3D.centreY + y * G3D.persY / Z);
    }
    
    
    
    
    
    public final void setMatrix(Matrix m) {
        x = (short) ((xReal*m.m00 + yReal*m.m01 + zReal*m.m02)>>12); //умножаем вершину на все вектора матрицы
        y = (short) ((xReal*m.m10 + yReal*m.m11 + zReal*m.m12)>>12);
        z = (short) ((xReal*m.m20 + yReal*m.m21 + zReal*m.m22)>>12);
        
        x += m.m03;//перемещаем вершину
        y += m.m13;
        z += m.m23;
        
        set2D();
    }
    
    
    
    
    
    
    
}